#include <vector>
#include <pair.h>

using std::vector;
using std::pair;

#include "mode.hh"
#include "channel.hh"
#include "agent.hh"
#include "list.hh"

class ActMap
{
#define C(what) \
      private: Lista<what> what##s; \
      public: void Add##what(const what &a) { what##s.Add(a); } \
              unsigned what##Index(const what &a) const { return what##s.Index(a); }
    
    C(Agent)
    C(Channel)
    C(Mode)
    
#undef C
	Lista<pair<unsigned, unsigned> > agchan;
	
private:
    template<class T>
    class vector2d : private vector<T>
    {
        unsigned xd, yd;
    public:
        void SetDims(unsigned x, unsigned y) { xd=x; yd=y; resize(x*y); }
        T &at(unsigned x, unsigned y) { return operator[] (x*xd+y); }
    };
    
    struct point3d
    {
    	unsigned crossvalue, x, y, z;
    	point3d(unsigned xx,unsigned yy,unsigned zz) : x(xx),y(yy),z(zz) { }
    	point3d(unsigned cv, unsigned xx,unsigned yy,unsigned zz) : crossvalue(cv), x(xx),y(yy),z(zz) { }
    	bool operator< (const point3d &p) const { return crossvalue < p.crossvalue; }
    };
    
private:
    vector<bool> map, handled;

    unsigned MdInd(unsigned a, unsigned c, unsigned m) const;
    void Set(unsigned a, unsigned c, unsigned m);
    
    inline unsigned As() const { return Agents.Size();   }
    inline unsigned Cs() const { return Channels.Size(); }
    inline unsigned Ms() const { return Modes.Size();    }
    
    void Squarify();
public:
    void InitMap();
    void SetAgentChan(const Agent &ag, const Channel &ch);
    void SetChanMode(const Channel &ch, const Mode &md);
    void Optimize() { Squarify(); }
};
